#include <stdio.h>
#include <tcl.h>
#include <tk.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

int mistnost[3]; /*delka sirka,vyska*/
struct nabytek
{
	char jmeno[20];
	int delka,sirka,vyska;
	int x,y;
	char stena;
};

struct nabytek veci[1000];
int pocet_veci=0;
char *barvy[]={"blue","cyan","yellow","magenta","brown","gray","black","darkgray","SkyBlue","green","PapayaWhip","PeachPuff","azure","MistyRose","turquoise","PaleGreen","OliveDrab","DarkKhaki","gold","RosyBrown","IndianRed","coral","orange","maroon","plum","purple","seashell3","bisque4","LemonChiffon1"};
int last_color=0;

Tcl_Interp *interp;
int readfile(char *jmeno);
int kresli(ClientData cd,Tcl_Interp *interp,int argc, char **argv);
int zobr_nabytek(ClientData cd,Tcl_Interp *interp,int argc, char **argv);

int AppInit(Tcl_Interp *interp)
{
	Tk_Window main;

	main = Tk_CreateMainWindow(interp, NULL, "Nabytek", "nabytek");
	if (Tk_Init(interp) == TCL_ERROR) exit(1);
}

main(int argc,char **argv)
{
	if(argc!=2)
	{
		fprintf(stderr,"Pouziti: %s soubor\n",argv[0]);
		exit(0);
	}
	interp = Tcl_CreateInterp();
	AppInit(interp);
	if (Tcl_EvalFile(interp, "a.tcl") == TCL_ERROR) exit(0);
	Tcl_CreateCommand(interp,"kreslicmd",kresli,(ClientData)NULL,NULL);
	Tcl_CreateCommand(interp,"zobrn",zobr_nabytek,(ClientData)NULL,NULL);
	readfile(argv[1]);
	Tcl_Eval(interp,"kreslicmd");

	Tk_MainLoop();
}

int readfile(char *jmeno)
{
	FILE *fp;
	float xx,yy;

	fp=fopen(jmeno,"r");
	if (fp==NULL)
		exit(1);
	fscanf(fp,"%d",&mistnost[0]);
	fscanf(fp,"%d",&mistnost[1]);
	fscanf(fp,"%d",&mistnost[2]);


	while (!feof(fp))
	{
		fscanf(fp,"%s %d %d %d %f %f %c",&veci[pocet_veci].jmeno,
			&veci[pocet_veci].delka,&veci[pocet_veci].sirka,
			&veci[pocet_veci].vyska,&xx,&yy,&veci[pocet_veci].stena);
		veci[pocet_veci].y=yy;
		veci[pocet_veci].x=xx;
		printf("----------- %d ----------\n%s:%d,%d,%d...%d,%d...%c\n",pocet_veci,
			veci[pocet_veci].jmeno,veci[pocet_veci].delka,
			veci[pocet_veci].sirka,veci[pocet_veci].vyska,
			veci[pocet_veci].x,veci[pocet_veci].y,veci[pocet_veci].stena);
		pocet_veci++;
	}
	fclose(fp);
}


#define S 90
void ZobrazVec(Tcl_Interp *interp,int i)
{
	char s[1000];
		switch (veci[i].stena)
		{
			case 'n': /*north*/
			case 's': /*south*/
				sprintf(s,".zobr create rectangle %d %d %d %d -outline {} -fill %s",
				S+veci[i].x,S+veci[i].y,S+veci[i].x+veci[i].delka,
				S+veci[i].y+veci[i].sirka,barvy[i]);
				break;
			case 'e': /*west*/
			case 'w': /*east*/
				sprintf(s,".zobr create rectangle %d %d %d %d -outline {} -fill %s",
				S+veci[i].x,S+veci[i].y,S+veci[i].x+veci[i].sirka,
				S+veci[i].y+veci[i].delka,barvy[i]);
				break;
				/*
			default:
				if((veci[i].delka==0)||(veci[i].delka==mistnost[2]))
				sprintf(s,".zobr create line %d %d %d %d -width 4 -fill %s", S+veci[i].delka,S+veci[i].sirka,S+veci[i].delka+S+veci[i].vyska, S+veci[i].x,barvy[i]);
				break;
				*/
		}
		printf("s=%s\n",s);
		Tcl_Eval(interp,s);
}

int zobr_nabytek(ClientData cd,Tcl_Interp *interp,int argc, char **argv)
{
	int i;
	for(i=0;i<pocet_veci;i++)
	{
		if(strcmp(veci[i].jmeno,argv[1])==0)
		{
			ZobrazVec(interp,i);
		}
	}
	return TCL_OK;
}

void zobrleg(Tcl_Interp *interp,char *jmeno,char *barva)
{
	char s[1000];
	last_color++;
	sprintf(s,".leg.txt tag configure color%d -foreground %s",last_color,barva);
	Tcl_Eval(interp,s);
	sprintf(s,".leg.txt insert end {%s} d%d ",jmeno,last_color,last_color);
	Tcl_Eval(interp,s);
	sprintf(s,".leg.txt insert end {**********} color%d",last_color);
	Tcl_Eval(interp,s);
	sprintf(s,".leg.txt tag bind d%d <Any-Enter> \".leg.txt tag configure d%d -background #43ce80 -relief raised -borderwidth 1\"",last_color,last_color);
	Tcl_Eval(interp,s);
	sprintf(s,".leg.txt tag bind d%d <Any-Leave> \".leg.txt tag configure d%d -background {} -relief flat \"",last_color,last_color);
	Tcl_Eval(interp,s);
	sprintf(s,".leg.txt tag bind d%d <1> {zobrn %s}",last_color,jmeno);
	Tcl_Eval(interp,s);
	Tcl_Eval(interp,".leg.txt inser end {\n}");
}
int kresli(ClientData cd,Tcl_Interp *interp,int argc, char **argv)
{
/*delka sirka,vyska*/
	char s[1000];
	int i=0;


	/*mistnost*/
	sprintf(s,".zobr create line %d %d %d %d -width 1 -fill black",
		S+0,S+0,S+mistnost[0],S+0);
	Tcl_Eval(interp,s);
	sprintf(s,".zobr create line %d %d %d %d -width 1 -fill black",
		S+0,S+mistnost[1],S+mistnost[0],S+mistnost[1]);
	Tcl_Eval(interp,s);
	sprintf(s,".zobr create line %d %d %d %d -width 1 -fill black",
		S+0,S+0,S+0,S+mistnost[1]);
	Tcl_Eval(interp,s);
	sprintf(s,".zobr create line %d %d %d %d -width 1 -fill black",
		S+mistnost[0],S+0,S+mistnost[0],S+mistnost[1]);
	Tcl_Eval(interp,s);
	Tcl_Eval(interp,"legenda");

	/* nabytek */
	for(i=0;i<pocet_veci;i++)
	{
	printf("i=%d\n",i);
		ZobrazVec(interp,i);
		zobrleg(interp,veci[i].jmeno,barvy[i]);
	}
	Tcl_Eval(interp,".leg.txt mark set insert 0.0");
	Tcl_Eval(interp,".leg.txt configure -state disabled");
	
	
	return TCL_OK;
}
